// Borland C++ Builder
// Copyright (c) 1995, 1999 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'SME2XLS.pas' rev: 4.00

#ifndef SME2XLSHPP
#define SME2XLSHPP

#pragma delphiheader begin
#pragma option push -w-
#include <SMEEngine.hpp>	// Pascal unit
#include <ExportDS.hpp>	// Pascal unit
#include <SME2Cell.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <ActiveX.hpp>	// Pascal unit
#include <Db.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Sme2xls
{
//-- type declarations -------------------------------------------------------
#pragma option push -b-
enum TSMExportXLSVersion { exvExcel2, exvExcel3, exvExcel4, exvExcel5, exvExcel7, exvExcel8, exvExcel9 
	};
#pragma option pop

#pragma option push -b-
enum TXLSObjectKind { okUnknown, okHyperlink, okNote, okPicture, okImage, okGraphic, okMergedCells }
	;
#pragma option pop

class DELPHICLASS TXLSObject;
#pragma pack(push, 4)
class PASCALIMPLEMENTATION TXLSObject : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	TXLSObjectKind FObjectKind;
	
__published:
	__property TXLSObjectKind ObjectKind = {read=FObjectKind, write=FObjectKind, default=0};
public:
	#pragma option push -w-inl
	/* TObject.Create */ inline __fastcall TXLSObject(void) : System::TObject() { }
	#pragma option pop
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TXLSObject(void) { }
	#pragma option pop
	
};

#pragma pack(pop)

class DELPHICLASS TXLSPicture;
#pragma pack(push, 4)
class PASCALIMPLEMENTATION TXLSPicture : public TXLSObject 
{
	typedef TXLSObject inherited;
	
private:
	Graphics::TPicture* FPicture;
	int FSize;
	
public:
	__fastcall virtual TXLSPicture(void);
	__fastcall virtual ~TXLSPicture(void);
	int __fastcall GetPictureSize(void);
	int __fastcall GetPictureType(void);
	void __fastcall WriteToStream(Classes::TStream* strm);
	
__published:
	__property Graphics::TPicture* Picture = {read=FPicture, write=FPicture};
	__property int Size = {read=FSize, write=FSize, nodefault};
};

#pragma pack(pop)

class DELPHICLASS TXLSMergeCells;
#pragma pack(push, 4)
class PASCALIMPLEMENTATION TXLSMergeCells : public TXLSObject 
{
	typedef TXLSObject inherited;
	
private:
	Word FFirstCol;
	Word FFirstRow;
	Word FLastCol;
	Word FLastRow;
	
__published:
	__property Word FirstCol = {read=FFirstCol, write=FFirstCol, nodefault};
	__property Word FirstRow = {read=FFirstRow, write=FFirstRow, nodefault};
	__property Word LastCol = {read=FLastCol, write=FLastCol, nodefault};
	__property Word LastRow = {read=FLastRow, write=FLastRow, nodefault};
public:
	#pragma option push -w-inl
	/* TObject.Create */ inline __fastcall TXLSMergeCells(void) : TXLSObject() { }
	#pragma option pop
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TXLSMergeCells(void) { }
	#pragma option pop
	
};

#pragma pack(pop)

class DELPHICLASS TSMExportToXLS;
#pragma pack(push, 4)
class PASCALIMPLEMENTATION TSMExportToXLS : public Sme2cell::TSMExportToCellFile 
{
	typedef Sme2cell::TSMExportToCellFile inherited;
	
private:
	Classes::TMemoryStream* FTempFontStream;
	Classes::TList* lstFonts;
	Classes::TList* lstObjects;
	TSMExportXLSVersion FVersion;
	int FSheetIndex;
	int APos;
	int __fastcall GetFontFromTable(const Graphics::TFont* Font);
	Classes::TMemoryStream* __fastcall GetFontStream(void);
	int __fastcall GetXLSIndexByColor(Graphics::TColor color);
	
protected:
	_di_IStream OStream;
	Byte *pBuf;
	void __fastcall WriteFormats(void);
	virtual void __fastcall InternalBeforeProcess(void);
	virtual void __fastcall InternalAfterProcess(void);
	
public:
	void __fastcall WriteRecordHeader(Classes::TStream* Stream, int RecType, int Size);
	void __fastcall WriteMSOHeader(Word FBT, Word Version, Word Instance, int Size);
	void __fastcall Write_MSO_DGG(int ContainerSize);
	void __fastcall Write_MSO_BStoreContainer(int ContainerSize);
	virtual void __fastcall WriteFileBegin(void);
	virtual void __fastcall WriteFileEnd(void);
	virtual void __fastcall WriteDimensions(int intRowCount, int intColCount);
	virtual void __fastcall WriteColWidth(int intCurColumn, int intColWidth);
	virtual void __fastcall WriteData(Db::TField* fld, Smeengine::TCellType CellType, int ARow, int ACol
		, AnsiString AString, Classes::TAlignment al, Graphics::TFont* font, Graphics::TColor color);
	virtual void __fastcall WriteFont(Graphics::TFont* fn);
	virtual void __fastcall WriteRowStart(bool IsAddedTitle);
	void __fastcall WriteStyle(const AnsiString Style);
	virtual void __fastcall WriteFormat(int Index, AnsiString Format, bool IsFormat);
	__fastcall virtual TSMExportToXLS(Classes::TComponent* AOwner);
	virtual AnsiString __fastcall Extension();
	void __fastcall SaveToWorkbook(void);
	__property Classes::TMemoryStream* TempFontStream = {read=GetFontStream};
	__property TSMExportXLSVersion Version = {read=FVersion, write=FVersion, default=3};
	
__published:
	__property ExportStyle ;
public:
	#pragma option push -w-inl
	/* TSMExportBaseComponent.Destroy */ inline __fastcall virtual ~TSMExportToXLS(void) { }
	#pragma option pop
	
};

#pragma pack(pop)

//-- var, const, procedure ---------------------------------------------------

}	/* namespace Sme2xls */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Sme2xls;
#endif
#pragma option pop	// -w-

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// SME2XLS
